#include <iostream>

using namespace std;

int main()
{
    long long klin, N;
    int x=0, y=0;
    cin>>klin;
    long long kurinu=klin, nen=0;
    while(kurinu>0)
    {
        for(int n=3; n<=2000; n++)
        {
            if(n*(n-1)*(n-2)/6>kurinu) break;
            N=n;
        }
        kurinu-=N*(N-1)*(N-2)/6;
        nen+=N;
    }
    cout<<nen<<endl;
    while(klin>0)
    {
        for(int n=3; n<=2000; n++)
        {
            if(n*(n-1)*(n-2)/6>klin) break;
            N=n;
        }
        klin-=N*(N-1)*(N-2)/6;
        for(N; N>0; N--)
        {
            cout<<x<<" "<<y<<endl;
            x++;
            y++;
        }
        x++;
    }
    return 0;
}